
%% Simple scenario: calls only at start, task finishes when they are all served; basic reward
mcfg = struct;
% set model custom config fields
mcfg.h = 4;
mcfg.callmode = 'none';     % except those in x0
mcfg.resetmode = 'fixed';
mcfg.x0 = [1 0 1 0 1 0]';   % elev at 1st floor, calls at 2nd and 4th; note transpose
mcfg.episodic = 1;
mcfg.vis_pause = 0.01; 
% create model
model = elev('model', mcfg);

qcfg = struct;
% set any custom config here
qcfg.maxsteps = 200;
qcfg.maxtrials = 100;
qcfg.verb = 1;
% run qlearning
[Q, info] = simpleqlearn(qcfg, model);


%% More complicated scenario, stochastic calls, smaller capacity elevator; waiting-passengers reward
mcfg = struct;
mcfg.h = 4;
mcfg.cap = 4;
mcfg.callmode = 'rand';
mcfg.callprob = .015;       % can also be a vector
mcfg.resetmode = 'fixed'; 
mcfg.x0 = [1 0 0 0 0 0]';   % elev at 1st floor, no calls initially
mcfg.episodic = 0;          % continuing task, keep serving passengers until maxsteps exhausted
mcfg.vis_pause = 0.01;
mcfg.rewtype = 'wait';      % waiting-passengers reward
model = elev('model', mcfg);

qcfg = struct;
qcfg.maxsteps = 200;
qcfg.maxtrials = 100;
qcfg.verb = 3;
qcfg.lambda = .5;   % use elig trace
[Q, info] = simpleqlearn(qcfg, model);


%% Other examples:

% How to use preset calls (non-stochastic)
mcfg.callmode = 'fixed'; mcfg.callstab = rand(mcfg.h, 500) < .015;  % 500 fixed new calls
