function [X, R, K] = hillcar_traj_ode4(m, x0, U, K)
% Simulates a trajectory of the hill-car using a 4th order fixed-step Runge-Kutta method.
% The vector of discrete-time ZOH controls is given in U, the max number of steps in K
% In the returned R, rewards start from index 2, the first reward is undefined (NaN)
% This function is now obsolete, no longer being maintained, and should not be used

% Reward is hardcoded -- check for mismatch
disp('WARNING: hillcar_traj_ode4 is obsolete and should not be used');
if isfield(model, 'rewtype') && model.rewtype(1) ~= 't',
    error('hillcar_mc_fuzzyqiter_ode4 only supports [term] reward type');
end;

odesteps = m.disc.odesteps; maxx = m.maxx;
N = K*odesteps + 1;
h = m.Ts / odesteps;
X = zeros(m.p, N);
R = zeros(1, K); R(1) = NaN;
F = zeros(m.p, 4);

X(:,1) = x0;
u = U(1);
for i = 2:N,
    xi = X(:,i-1);
    f1 = hillcar_trans(xi,u);
    f2 = hillcar_trans(xi+0.5*h*f1,u);
    f3 = hillcar_trans(xi+0.5*h*f2,u);  
    f4 = hillcar_trans(xi+h*f3,u);
    X(:,i) = xi + (h/6)*(f1 + 2*f2 + 2*f3 + f4);
    if ~mod((i-1), odesteps),       
        % we are at the last step of a sample
        % index of NEXT sample
        k = (i-1)/odesteps+1;
        x = X(:,i);
        if abs(x) <= maxx,          % regular state
            R(k) = 0;               % note k is the theoretical k+1
            % apply the next command (unless at the last sample)
            if i < N, u = U(k); end;
        else                        % terminal state
            % -1 to the left or when speed exceeds bound, 1 otherwise
            R(k) = -1 + 2*(x(1) > maxx(1) && x(2) <= maxx(2));
            % terminate, after setting the counters and vectors accordingly
            N = i;
            K = k;
            R = R(1:K);
            % also bound the terminal state (for the sake of the approximators)
            X(:,i) = max(-maxx, min(maxx, x));
            break;
        end;
    end;
end;
% pick only the states at the sample times, the intermediate values are not interesting
X = X(:, 1:odesteps:N);

end
