function editorfiles(m, f)
% Save the list of open files in editor; re-open files
%   EDITORFILES(M, F)
% Parameters:
%   M = 'save'      - save list of files into file F
%   M = 'open'      - open list of files previously saved into F

switch m(1),
    case 's',       % save list of files 
        e = com.mathworks.mlservices.MLEditorServices;
        ef = char(e.builtinGetOpenDocumentNames);
        save(f, 'ef');
    case 'o',       % open list of files
        load(f, 'ef');
        for i = 1:size(ef, 1),
            try
                open(strtrim(ef(i, :)));
            catch
                % do nothing, skip the file
            end;
        end;
end;
        
