function xseq = malinear_simagent(m, x, useq, K)
%  Simulate a single agent in a system of discrete-time, decoupled, homogeneous linear agents.
%  [XFIN] = MALINEAR_SIMAGENT(M, X, USEQ, IAGENT, G)
%  Parameters:
%   M           - the model specification
%   X           - current state, x(k) of the agent
%   USEQ        - command sequence u(k), ..., u(k+K-1) for the agent: matrix of flat vectors
%  Returns:
%   XSEQ        - resulting sequence of states, x(k), x(k+1), ..., x(k+K)

xseq = zeros(m.p(1), K+1); xseq(:, 1) = x; 
for k = 1:K, xseq(:, k+1) = m.A * xseq(:, k) + m.B * useq(:, k); end;

end