% What experiments to process and in what mode
exp = 'all';
mode = 'run';       % 'run', 'sol', 'stats', 'cleanup'

% main cfg
cfg = struct;
cfg.(mode) = 1;
cfg.gamma = .95;
cfg.problem = 'dc_problem';
cfg.model_params = {'lqr Q=[5,.02] R=.05', 'lin'}; % Larger LQR weights, lin model
cfg.datadir = pwd;
cfg.Ns = 10000;
cfg.xspace = 'eq'; cfg.uspace = 'log';
cfg.maxiter  = 100;
cfg.infix = 'evol';
% perf eval
cfg.perf = 1;                       % turn off for now, we care about iter only
cfg.X0 = 'coarse';                  % when evaluating performance, use coarse grid
cfg.mc_eps = 0.1;      
% replay
cfg.x0 = [pi;0]; cfg.tend = 1.5;
if any(strcmp(mode, {'stats', 'plot'})), cfg.verb = 0; else cfg.verb = 5; end;

expout = [];        % reset figure additions
% -------- TRIANG experiments
% TRIANGULAR discrete
texp = cfg;
texp.type     = 'triang'; texp.miscinfo = 't';
texp.N        = 9; texp.M = [3 7]; 
texp.method   = 'randdisc';
if checkrunexp(texp.miscinfo, exp), expout = lspiexp(texp); end;

% TRIANGULAR quad
toexp = cfg;
toexp.type     = 'triangortho'; toexp.miscinfo = 'to';
toexp.N        = 9; toexp.M = 2;
toexp.method   = 'rand';
if checkrunexp(toexp.miscinfo, exp), expout = lspiexp(toexp); end;

% -------- RBF experiments

% RBF discrete
rexp = cfg;
rexp.type     = 'rbfdisc'; rexp.miscinfo = 'r';
rexp.N        = 9; rexp.M = [3 7]; 
rexp.method   = 'randdisc';
if checkrunexp(rexp.miscinfo, exp), expout = lspiexp(rexp); end;

% RBF ortho
roexp = cfg;
roexp.type     = 'rbfortho'; roexp.miscinfo = 'ro';
roexp.N        = 9; roexp.M = 2;
roexp.method   = 'rand';
if checkrunexp(roexp.miscinfo, exp), expout = lspiexp(roexp); end;



