% Explicitly parameterized policies vs. exact policy improvements
% vs. policy improvement with monotonicity constraints

% Large gamma experiment.
% This should actually be merged into lspidc_hcon, but I don't have the time now

exp = 'r*';
mode = 'stats';       % 'run', 'sol', 'stats', 'cleanup'

% main cfg
cfg = struct;
cfg.(mode) = 1;
cfg.gamma = .99;
cfg.problem = 'dc_problem';
cfg.model_params = {'lqr Q=[5,.02] R=.05', 'lin'}; % Larger LQR weights, lin model
cfg.datadir = pwd;
% sample config is constant
cfg.adaptiveNs = 1;
cfg.method = 'rand'; cfg.Ns = 5000;
cfg.hmethod = 'rand'; cfg.hNs = 1000;
cfg.xspace = 'eq'; % cfg.uspace = 'log'; -- never used, we don't have disc approx currently
cfg.maxiter  = 50;
cfg.repeat = 5;
% perf eval
cfg.perf = 1;
cfg.forceeval = 1;                  % to evaluate performance even for non-convergent experiments
cfg.X0 = 'coarse';                  % when evaluating performance, use coarse grid
cfg.mc_eps = 0.1;      
cfg.show = {'rep', 'gamma'};
% replay
cfg.x0 = [pi;0]; cfg.tend = 1.5;
% if any(strcmp(mode, {'stats', 'plot'})), cfg.verb = 0; else cfg.verb = 5; end;

% Specialized configs
% exact policy improvement config
excfg = cfg;
excfg.alg = 'lspi';
excfg.infix = 'exact';

% explicit policy parameterization
hcfg = cfg;
hcfg.alg = 'lspih';
hcfg.infix = 'nilc';

% explicit policy parameterization with monotonicity constraints
hconcfg = cfg;
hconcfg.alg = 'lspih';
hconcfg.infix = 'mon';
hconcfg.con = 'type=mon dir=[-1,-1]';

% ===========================
% RBF ortho experiments
% exact himprove
expout = [];        % reset figure additions
roexp = excfg;
roexp.type     = 'rbfortho'; roexp.miscinfo = 'ro';
roexp.N        = 9; roexp.M = [2 3]; 
if checkrunexp(roexp.miscinfo, exp), expout = lspiexp(roexp); end;
% parameterized policy 
rohexp = hcfg;
rohexp.type     = 'rbfortho'; rohexp.miscinfo = 'roh';
rohexp.N        = 9; rohexp.M = [2 3]; 
rohexp.htype    = 'rbfsing';
rohexp.usesamples = roexp;
if checkrunexp(rohexp.miscinfo, exp), expout = lspiexp(rohexp); end;
% monotonous constraints
rohcexp = hconcfg;
rohcexp.type     = 'rbfortho'; rohcexp.miscinfo = 'rohc';
rohcexp.N        = 9; rohcexp.M = [2 3];  
rohcexp.htype    = 'rbfsing';
rohcexp.usesamples = rohexp;
if checkrunexp(rohcexp.miscinfo, exp), expout = lspiexp(rohcexp); end;
