exp = '*g';
mode = 'stats';
c = struct;

% main cfg
cfg = struct;
cfg.(mode) = 2;
cfg.problem = 'dc_problem';
cfg.gamma = 0.98;
cfg.maxiter  = 50;
cfg.repeat = 5;
cfg.Mpoly = [2 3 4];
cfg.xspace = 'eq'; cfg.uspace = 'log';
cfg.Ns = 10000;                 % baseline for adaptive Ns
cfg.samesamples = 0; cfg.adaptiveNs = 1;
cfg.show = {'gamma', 'rep'};
cfg.datadir = pwd;
% perf eval
cfg.perf = 1;
cfg.X0 = 'coarse';
cfg.mc_eps = 0.01; 
% replay
cfg.x0 = [pi;0]; cfg.tend = 1;    % for replaying
% plot
if strcmp(mode, 'plot'), 
    cfg.stats = 1;
    cfg.plot = {'J', 'iter'}; 
end;
if any(strcmp(mode, {'stats', 'plot'})), cfg.verb = 0; else cfg.verb = 5; end;

expout = [];    % dummy

% =====================
% GAUSS reward
cfg_gauss = cfg;
cfg_gauss.model_params = {'gauss', 'lin'};
cfg_gauss.infix = 'gauss';

% TRIANG
toexp_g = cfg_gauss;          % ortho
toexp_g.type     = 'triangortho'; toexp_g.miscinfo = 'tog';
toexp_g.N        = 9; toexp_g.M = cfg.Mpoly;
toexp_g.orthotype = 'cheby';
toexp_g.method   = 'rand'; 
toexp_g.addtocrt = 0; toexp_g.expprefix = 'ortho,';     % only effective in stats+plot mode
if checkrunexp(toexp_g.miscinfo, exp), expout = lspiexp(toexp_g); end;

texp_g = cfg_gauss;       % disc
texp_g.type     = 'triang'; texp_g.miscinfo = 'tg';
texp_g.N        = 9; texp_g.M = 3;
texp_g.method   = 'randdisc';
texp_g.addtocrt = expout; texp_g.expprefix = 'discrete,'; % only effective in stats+plot mode
if checkrunexp(texp_g.miscinfo, exp), expout = lspiexp(texp_g); end;

% RBF
roexp_g = cfg_gauss;            % ortho
roexp_g.type     = 'rbfortho'; roexp_g.miscinfo = 'rog';
roexp_g.N        = 9; roexp_g.M = cfg.Mpoly; 
roexp_g.orthotype = 'cheby';
roexp_g.method   = 'rand';
roexp_g.usesamples = toexp_g;
roexp_g.addtocrt = 0; roexp_g.expprefix = 'ortho,'; % only effective in stats+plot mode
if checkrunexp(roexp_g.miscinfo, exp), expout = lspiexp(roexp_g); end;

rexp_g = cfg_gauss;       % disc
rexp_g.type     = 'rbfdisc'; rexp_g.miscinfo = 'rg';
rexp_g.N        = 9; rexp_g.M = 3;
rexp_g.method   = 'randdisc';
rexp_g.usesamples = texp_g;
rexp_g.addtocrt = expout; rexp_g.expprefix = 'discrete,'; % only effective in stats+plot mode
if checkrunexp(rexp_g.miscinfo, exp), expout = lspiexp(rexp_g); end;

% =================
% BOX reward
cfg_box = cfg;
cfg_box.model_params = {'box', 'lin'};
cfg_box.infix = 'box';
cfg_eps = 0.001;
cfg.mc_eps = 0.001; 

% TRIANG
toexp_b = cfg_box;          % ortho
toexp_b.type     = 'triangortho'; toexp_b.miscinfo = 'tob';
toexp_b.N        = 9; toexp_b.M = cfg.Mpoly;
toexp_b.orthotype = 'cheby';
toexp_b.method   = 'rand'; 
toexp_b.addtocrt = 0; toexp_b.expprefix = 'ortho,';     % only effective in stats+plot mode
if checkrunexp(toexp_b.miscinfo, exp), expout = lspiexp(toexp_b); end;

texp_b = cfg_box;       % disc
texp_b.type     = 'triang'; texp_b.miscinfo = 'tb';
texp_b.N        = 9; texp_b.M = 3;
texp_b.method   = 'randdisc';
texp_b.addtocrt = expout; texp_b.expprefix = 'discrete,'; % only effective in stats+plot mode
if checkrunexp(texp_b.miscinfo, exp), expout = lspiexp(texp_b); end;

% RBF
roexp_b = cfg_box;            % ortho
roexp_b.type     = 'rbfortho'; roexp_b.miscinfo = 'rob';
roexp_b.N        = 9; roexp_b.M = cfg.Mpoly; 
roexp_b.orthotype = 'cheby';
roexp_b.method   = 'rand';
roexp_b.usesamples = toexp_b;
roexp_b.addtocrt = 0; roexp_b.expprefix = 'ortho,'; % only effective in stats+plot mode
if checkrunexp(roexp_b.miscinfo, exp), expout = lspiexp(roexp_b); end;

rexp_b = cfg_box;       % disc
rexp_b.type     = 'rbfdisc'; rexp_b.miscinfo = 'rb';
rexp_b.N        = 9; rexp_b.M = 3;
rexp_b.method   = 'randdisc';
rexp_b.usesamples = texp_b;
rexp_b.addtocrt = expout; rexp_b.expprefix = 'discrete,'; % only effective in stats+plot mode
if checkrunexp(rexp_b.miscinfo, exp), expout = lspiexp(rexp_b); end;
