clear cfg;

% cfg.experiments = 'avg grad sum lsqr pinv fuzzy';
cfg.experiments = 'pin2 pin3';

cfg.datafile = 'tqdi_avg';
cfg.loadtiling = 'tqdi_lsqr';
cfg.method = 'avg';
cfg.run = 1;
cfg.maxiter = 500;
if findstr('avg', cfg.experiments),
    doubleint_tilingqit(cfg);
end;

% use same tiling for the other algorithms
cfg.loadtiling = 'tqdi_avg';

cfg.maxiter = 200;      % no point in running longer, these diverge

if findstr('grad', cfg.experiments),
    cfg.method = 'grad';
    cfg.datafile = 'tqdi_grad';
    doubleint_tilingqit(cfg);
end;
    
if findstr('sum', cfg.experiments),
    cfg.method = 'sum';
    cfg.datafile = 'tqdi_sum';
    doubleint_tilingqit(cfg);
end;

if findstr('lsqr', cfg.experiments),
    cfg.method = 'lsqr';
    cfg.datafile = 'tqdi_lsqr';
    doubleint_tilingqit(cfg);
end;

if findstr('pinv', cfg.experiments),
    cfg.method = 'pinv';
    cfg.datafile = 'tqdi_pinv';
    doubleint_tilingqit(cfg);
end;

if findstr('pin2', cfg.experiments),
    cfg.method = 'pinv';
    cfg.loadtiling = '';
    cfg.tcfg.c = 2;
    cfg.datafile = 'tqdi_pinv2';
    doubleint_tilingqit(cfg);
end;

if findstr('pin3', cfg.experiments),
    cfg.method = 'pinv';
    cfg.loadtiling = '';
    cfg.tcfg.c = 3;
    cfg.datafile = 'tqdi_pinv3';
    doubleint_tilingqit(cfg);
end;


if findstr('fuzzy', cfg.experiments),
    cfg.datafile = 'fzqdi';
    cfg.run = 1;
    cfg.problem = 'doubleint_problem';
    cfg.eps = .01;
    fuzzyqi(cfg);
end;