
figh = [];

clear cfg;
cfg.run = 0;
cfg.replay = 1;
cfg.datafile = 'tqdi_avg';
cfg.interph = 1;
cfg.tend = 50;
cfg.x0 = [10 0]';
cfg.plottarget = 'latex';
cfg.savedir = 'D:\Work\tex\reports\2007-03-21_tilingQiteration\img\';
cfg.savefig = 'tiling_traj';
doubleint_tilingqit(cfg);


cfg.problem = 'doubleint_problem';
cfg.datafile = 'fzqdi';
cfg.savefig = 'fuzzy_traj';
fuzzyqi(cfg);

% --------------------

load tqdi_grad qistats
grads = qistats;
load tqdi_sum qistats
sums = qistats;

figh(end+1) = figurex([600 300]);
semilogy(grads.delta, 'k-'); hold on;
semilogy(sums.delta, 'k--');
legend('Gradient tiling Q-iteration', 'Summing tiling Q-iteration', 'Location', 'SouthEast');
xlabel('$\ell$', 'Interpreter', 'Latex');
ylabel('$\Vert \theta^* - \theta_\ell \Vert_\infty$', 'interpreter', 'Latex');
saveplot(gcf, [cfg.savedir 'grad_sum_div'], cfg.plottarget);

% --------------------

% load tqdi_lsqr qistats
% lsqrs = qistats;
load tqdi_pinv qistats
pinv8 = qistats;
load tqdi_pinv2 qistats
pinv2 = qistats;
load tqdi_pinv3 qistats
pinv3 = qistats;

figh(end+1) = figurex([600 300]);
semilogy(pinv8.delta, 'k-'); hold on;
semilogy(pinv3.delta, 'k--'); hold on;
semilogy(pinv2.delta, '-', 'Color', [.5 .5 .5], 'LineWidth', 2); hold on;
legend('c = 8', 'c = 3', 'c = 2', 'Location', 'SouthWest');
xlabel('$\ell$', 'Interpreter', 'Latex');
ylabel('$\Vert \theta^* - \theta_\ell \Vert_\infty$', 'interpreter', 'Latex');
saveplot(gcf, [cfg.savedir 'lsqr_div'], cfg.plottarget);

pause; close(figh);
