% LSPI on the invpend problem, for comparison with LLR fitted QI

%% #### General config
% clear all; closeall;

% TODO are these results good? why always failing?

% batch experiment
BCFG = struct;
BCFG.alg = 'lspi';
BCFG.verb = 5;

% algorithm
ACFG = struct;
ACFG.problem = 'hillcar_problem';
ACFG.gamma = .95;
ACFG.maxiter  = 200;
ACFG.eps = 0.01;        % make this small since the rewards have small magnitude in the hillcar problem
ACFG.epsper = 0.01;
ACFG.approx.enhanced = 1;
ACFG.approx.type = 'triang';
ACFG.approx.N = [11 11]; ACFG.approx.xspace = 'eq';
ACFG.approx.M = 2; ACFG.approx.uspace = 'eq';
ACFG.datadir = 'd:\work\m\approxrl\systems\hillcar\llrfqi_hc_lspicomparison';
ACFG.verb = 3;
% perf eval options
ACFG.mc_eps = .01;
ACFG.mc_N = 1;
ACFG.X0 = 'posspeed';

cd(ACFG.datadir);


%% #### Experiment 1: effect of #samples // grid sampling

bcfg = BCFG;
bcfg.mode = 'run';
bcfg.idinfix = 'Nsgrid';
bcfg.idfields = {'alg', 'problem', 'approxtype', 'approxN', 'samplesmethod', 'samplesxgrids'};
bcfg.repeat = 1;
% perf eval options
bcfg.in = 'samplesxgrids';

acfg = ACFG;
acfg.samples.method = 'grid';
acfg.samples.gridfun = @symequidgrid;
acfg.samples.xgrids = {[15, 15], [31 31], [51 51], [71 71]};
acfg.samples.ugrids = {[-4 4]};

%% Run
processbatch(bcfg, acfg);

%% Eval in own figure
bcfg.out = 'score';

bcfg.addtocrt = 0; bcfg.plotindex = 1;
evalbatch(bcfg, acfg);

%% Eval adding to current
bcfg.out = 'score';

bcfg.addtocrt = 1; bcfg.plotindex = 2;
evalbatch(bcfg, acfg);


%% #### Experiment 2: effect of knn and #samples // unif random sampling

bcfg = BCFG;
bcfg.mode = 'run';
bcfg.idinfix = 'Nsrand';
bcfg.idfields = {'alg', 'problem', 'approxtype', 'approxN', 'samplesmethod', 'samplesN'};
bcfg.repeat = 10;
bcfg.in = 'samplesN';

acfg = ACFG;
acfg.samples.method = 'randdisc';
acfg.samples.ugrids = {[-4 4]};
acfg.samples.N = [15 31 51 71].^2 * 2;  

%% Run
processbatch(bcfg, acfg);

%% Eval in own figure
bcfg.out = 'score';
bcfg.addtocrt = 0; bcfg.plotindex = 1;

acfg.samples.N = [31 51 71].^2 * 2;     % we don't bother with 15x15 since A is noninv for all those    

evalbatch(bcfg, acfg);

%% Eval adding to current
bcfg.out = 'score';

acfg.samples.N = [31 51 71].^2 * 2;     % we don't bother with 15x15 since A is noninv for all those    

bcfg.addtocrt = 1; bcfg.plotindex = 2;
evalbatch(bcfg, acfg);
