function eval_cepssti(cfg)

% Compare STI strategies with no treatment; and fully eficacious
% treatment

% This file is very ad-hoc; it is kept for compatibiliy reasons and 
% should not be used further. Instead, create plots explicitly

% global config
CFG.infdatafiles = {};
CFG.unhdatafiles = {'hiv_unh_max_8_c10', 'hiv_unh_max_8_alpha05'};
CFG.postfix = '';
CFG.plottarget = 'screen';
CFG.datadir = 'd:\work\m\approxrl\systems\hiv\';
CFG.savedir = 'd:\work\m\approxrl\systems\hiv\';
CFG.cepsopt = [];

% Configs for run experiments 
% -- DO NOT UNCOMMENT, BUT RUN FROM COMMAND LINE
% eval_cepssti('plottarget=fig infdatafiles=hiv_inf_max unhdatafiles=hiv_unh_max savedir=d:\work\m\approxrl\systems\hiv\max_N8_gamma099\');
% eval_cepssti('plottarget=fig infdatafiles={''hiv_inf_vot#1'',''hiv_inf_vot#2''} savedir=d:\work\m\approxrl\systems\hiv\vot_N8_gamma099_inf\');
% eval_cepssti('plottarget=fig infdatafiles=hiv_inf_vot_15 unhdatafiles=hiv_unh_vot_15 savedir=d:\work\m\approxrl\systems\hiv\vot_N15_gamma098\');
% eval_cepssti('plottarget=fig unhdatafiles={''hiv_unh_vot_10_rho0005'',''hiv_ucs_vot_10_rho001''} savedir=d:\work\m\approxrl\systems\hiv\vot_N10_gamma1_smallrho_ucs\');
% eval_cepssti('plottarget=fig unhdatafiles={''hiv_unh_max_8_c10'',''hiv_unh_max_8_alpha05''} savedir=d:\work\m\approxrl\systems\hiv\max_N8_gamma1_c10_smooth05\');
% eval_cepssti('plottarget=fig unhdatafiles=hiv_unh_max_8_raw infdatafiles=hiv_inf_max_8_raw savedir=d:\work\m\approxrl\systems\hiv\max_N8_raw\');
% eval_cepssti('plottarget=fig unhdatafiles={''hiv_unh_max_8_c10_raw'',''hiv_unh_max_8_smooth05_raw''} savedir=d:\work\m\approxrl\systems\hiv\');
% eval_cepssti('plottarget=fig unhdatafiles={''hiv_unh_max_12_smooth05'',''hiv_ucs_max_8_smooth05''} savedir=d:\work\m\approxrl\systems\hiv\');
% eval_cepssti('plottarget=fig unhdatafiles=hiv_unh_max_8_c10_gamma098 infdatafiles=hiv_inf_max_8_c10_gamma098 savedir=d:\work\m\approxrl\systems\hiv\');

% process config
if nargin < 1, cfg = struct; end;
if ischar(cfg),  cfg = str2cfg(cfg, fieldnames(CFG)); end;
cfg = checkparams(cfg, CFG);
cfg.grayscale = grayscalefromconfig(cfg);

% allow for single files
if ischar(cfg.infdatafiles), cfg.infdatafiles = {cfg.infdatafiles}; end;
if ischar(cfg.unhdatafiles), cfg.unhdatafiles = {cfg.unhdatafiles}; end;

% common config
ccfg.tend = 800;
ccfg.noplot = 1;
ccfg.problem = 'hiv_problem';
if ~isempty(cfg.cepsopt),
    ccfg = copyfields(cfg.cepsopt, ccfg);
end;

% change dir to savedir, assuming datafiles are there & the dir is not
% necessarily on the path
if ~isempty(cfg.datadir),
    crtdir = pwd;
    cd(cfg.datadir);
end;

% =========================
% first, infected

% baselines
zcfg = ccfg;
zcfg.x0 = 'infected'; zcfg.policy = @(varargin)[0;0];
zh = clreplay('hiv_problem', zcfg); 

fcfg = ccfg;
fcfg.x0 = 'infected'; fcfg.policy = @(varargin)[0.7;0.3];
fh = clreplay('hiv_problem', fcfg);

% CE
for i = 1:length(cfg.infdatafiles),
    if length(cfg.infdatafiles) > 1,     idxpostfix = ['_' num2str(i)];
    else                                 idxpostfix = '';
    end;
    
    cecfg = ccfg;
    cecfg.replay = 1;
    cecfg.datafile = cfg.infdatafiles{i};
    cecfg.x0 = 'infected';
    ceh = cerbfps(cecfg);

    clear plotcfg;
    plotcfg.datafile = cfg.infdatafiles{i}; 
    plotcfg.problem = 'hiv_problem';
    plotcfg.trajectory = 1;

    plotcfg.addtocrt=0; plotcfg.hist = ceh; hiv_plot(plotcfg); 

    plotcfg.addtocrt=1; plotcfg.styleindex = 2; plotcfg.hist = zh; hiv_plot(plotcfg);

    plotcfg.addtocrt=1; plotcfg.styleindex = 3; plotcfg.hist = fh; 
    plotcfg.savedir = cfg.savedir;
    plotcfg.plottarget = cfg.plottarget;
    plotcfg.savefig = ['hiv_traj_inf_'  cfg.postfix idxpostfix];
    hiv_plot(plotcfg);

    % also save stats
    cerbfps(['stats datafile=' cfg.infdatafiles{i} ...
        ' plottarget=' cfg.plottarget ' savedir=' plotcfg.savedir ...
        ' savefig=hiv_conv_inf_' cfg.postfix idxpostfix]);
end;

% =========================
% then, unhealthy

% baselines
zcfg = ccfg;
zcfg.x0 = 'unhealthy'; zcfg.policy = @(varargin)[0;0];
zh = clreplay('hiv_problem', zcfg); 

fcfg = ccfg;
fcfg.x0 = 'unhealthy'; fcfg.policy = @(varargin)[0.7;0.3];
fh = clreplay('hiv_problem', fcfg);

% CE
for i = 1:length(cfg.unhdatafiles),

    if length(cfg.unhdatafiles) > 1,    idxpostfix = ['_' num2str(i)];
    else                                idxpostfix = '';
    end;
    cecfg = ccfg;
    cecfg.replay = 1;
    cecfg.datafile = cfg.unhdatafiles{i};
    cecfg.x0 = 'unhealthy';
    ceh = cerbfps(cecfg);

    clear plotcfg;
    plotcfg.datafile = cfg.unhdatafiles{i}; 
    plotcfg.problem = 'hiv_problem';
    plotcfg.trajectory = 1;
    plotcfg.savedir = cfg.savedir;
    plotcfg.plottarget = cfg.plottarget;
    plotcfg.savefig = ['hiv_traj_unh_' cfg.postfix idxpostfix];

    plotcfg.addtocrt=0; plotcfg.hist = ceh; hiv_plot(plotcfg);
    plotcfg.addtocrt=1; plotcfg.styleindex = 2; plotcfg.hist = zh; hiv_plot(plotcfg);
    plotcfg.addtocrt=1; plotcfg.styleindex = 3; plotcfg.hist = fh; 
    hiv_plot(plotcfg);

    % also save stats
    scfg = ccfg;
    scfg.stats = 1;
    scfg.noplot = 0;
    scfg.datafile = cfg.unhdatafiles{i};
    scfg.plottarget = cfg.plottarget;
    scfg.savedir = plotcfg.savedir;
    scfg.savefig = ['hiv_conv_unh_' cfg.postfix idxpostfix];
    cerbfps(scfg);
end;

% change dir back if needed
% change dir to savedir, assuming datafiles are there
if ~isempty(cfg.savedir),
    cd(crtdir);
end;
