% What experiments to process and in what mode
exp = {'all'};
mode = 'cleanup';       % 'run', 'sol', 'stats', 'cleanup'

% main cfg
cfg = struct;
cfg.(mode) = 2;
cfg.problem = 'invpend_problem';
% this should not give convergence problems, while still giving a time horizon for a good solution
% (but it does give conv problems!)
cfg.gamma = 0.96;
cfg.maxiter  = 100;
cfg.repeat = 1;
cfg.xspace = 'eq'; cfg.uspace = 'log';
% perf eval
cfg.perf = 1;                       % turn off for now, we care about iter only
cfg.verb = 0;
cfg.X0 = 'coarse';                  % when evaluating performance, use coarse grid
cfg.mc_eps = 0.1;      
cfg.x0 = [pi;0]; cfg.tend = 5;    % for replaying
cfg.datadir = pwd;
cfg.samesamples = 1;
cfg.show = {'gamma', 'rep'};
cfg.model_params = {'lqr', 'rot', 'Ts=0.02'};

cfgdelta = cfg;
cfgdelta.lspi_params = struct('invdelta', 1e-3); cfgdelta.infix = 'd1m3';
% cell array of experiment configs
CFG = {};

% Discrete actions -- Zero A init
cexp = cfg;
cexp.type     = 'triang'; cexp.miscinfo = 't11/3/10000';
cexp.N        = 11; cexp.M = 3;
cexp.method   = 'randdisc';
cexp.Ns       = 10000;
CFG{end+1} = cexp; 
discsampcfg = cexp;

cexp = cfg;
cexp.type     = 'rbfdisc'; cexp.miscinfo = 'rd11/3/10000';
cexp.N        = 11; cexp.M = 3;
cexp.method   = 'randdisc';
cexp.Ns       = 10000;
cexp.usesamples = discsampcfg;
CFG{end+1} = cexp;

% Polynomials -- Zero A init
cexp = cfg;
cexp.type     = 'triangpoly'; cexp.miscinfo = 'tp11/10000';
cexp.N        = 11; cexp.M = [2 3 4];
cexp.method   = 'rand';
cexp.Ns       = 10000;
CFG{end+1} = cexp;
contsampcfg = cexp;

cexp = cfg;
cexp.type     = 'rbfpoly'; cexp.miscinfo = 'rp11/10000';
cexp.N        = 11; cexp.M = [2 3 4];
cexp.method   = 'rand';
cexp.Ns       = 10000;
cexp.usesamples = contsampcfg;
CFG{end+1} = cexp;

% Discrete actions  -- Delta A init
cexp = cfgdelta;
cexp.type     = 'triang'; cexp.miscinfo = 'deltat11/3/10000';
cexp.N        = 11; cexp.M = 3;
cexp.method   = 'randdisc';
cexp.Ns       = 10000;
cexp.usesamples = discsampcfg;
CFG{end+1} = cexp; 

cexp = cfgdelta;
cexp.type     = 'rbfdisc'; cexp.miscinfo = 'deltard11/3/10000';
cexp.N        = 11; cexp.M = 3;
cexp.method   = 'randdisc';
cexp.Ns       = 10000;
cexp.usesamples = discsampcfg;
CFG{end+1} = cexp;

% Polynomials -- Delta A init
cexp = cfgdelta;
cexp.type     = 'triangpoly'; cexp.miscinfo = 'deltatp11/10000';
cexp.N        = 11; cexp.M = [2 3 4];
cexp.method   = 'rand';
cexp.Ns       = 10000;
cexp.usesamples = contsampcfg;
CFG{end+1} = cexp;

cexp = cfgdelta;
cexp.type     = 'rbfpoly'; cexp.miscinfo = 'deltarp11/10000';
cexp.N        = 11; cexp.M = [2 3 4];
cexp.method   = 'rand';
cexp.Ns       = 10000;
cexp.usesamples = contsampcfg;
CFG{end+1} = cexp;

% Main experiment loop
for i = 1:length(CFG),
    if any(strcmp(CFG{i}.miscinfo, exp)) || any(strcmp('all', exp)),
        lspiexp(CFG{i});
    end;
end;
