function [xplus, rplus, terminal] = linsys_lsf_mdp(m, x, k)
% Implements the discrete-time dynamics of a linear system.
% A linear state feedback vector (*ISO assumed) is taken as an inpput instead of the 
% direct control signal
%  [XPLUS, RPLUS, TERMINAl] = LINSYS_LSF_MDP(M, X, U)
%
% This function conforms to the specifications established by SAMPLE_MDP.

u = min(max(k' * x, -m.maxcmd), m.maxcmd);
xplus = min(max(m.A * x + m.B * u, -m.maxx), m.maxx);
rplus = m.zeroreward * all(abs(x) <= m.zeroband);

terminal = 0;

% END FUNCTION linsys_mdp() RETURNING xplus, rplus ==================================================
