function [xplus, rplus, terminal] = linsys_mdp(m, x, u)
% Implements the discrete-time dynamics of a linear system
%  [XPLUS, RPLUS, TERMINAl] = LINSYS_MDP(M, X, U)
%
% This function conforms to the specifications established by SAMPLE_MDP.

% u = sat(u, -m.maxu, m.maxu);

xplus = min(max(m.A * x + m.B * u, -m.maxx), m.maxx);

rplus = m.zeroreward * all(abs(x) <= m.zeroband);

terminal = 0;

% END FUNCTION linsys_mdp() RETURNING xplus, rplus ==================================================
