% Example from Henrion et al. paper, where cost is optimized

%% config
clear all;
x0 = [0; -1];
Ts = 0.01;
Act1 = [-1 2; 1 -3]; Act2 = [-2 -2; 1 -1];
A1 = expm(Act1 * Ts); A2 = expm(Act2 * Ts); 

mcfg.A = {A1, A2};
mcfg.Q = eye(2);
mcfg.maxx = [1.5; 1.5];
mcfg.dwelltime = 1;
mcfg.rewtype = 'opt';
% dummym = switchedlin_problem('model', mcfg);

cfg = struct;
cfg.problem = 'switchedlin_problem';
cfg.model_params = {mcfg};
cfg.gamma = .99;
cfg.maxsteps = 2/Ts;
cfg.planalg = 'opd';
cfg.planparams.U = [1 2];
cfg.planparams.n = 100;
cfg.verb = 3;

%% run OPD allowing any initial mode
cfg.reset = x0;
cfg.run = 1;
cfg.datafile = 'swlin_henrion_test';
genmpc(cfg);

h = genmpc(['plottrial datafile=' cfg.datafile]);
% h.R(1)
cost = 0; for i = 1:length(h.x), cost = cost + Ts * h.x(:, i)' * mcfg.Q * h.x(:, i); end;
cost
