% Example from Henrion et al. paper, where cost is optimized

%% config
clear all;

x0 = 2000;

mcfg.type = 'affine';
mcfg.A = {1, 0.9}; mcfg.b = {0, -5};
mcfg.Q = 1;
mcfg.maxx = 2000;
mcfg.dwelltime = 1;
mcfg.userefmodel = 1;
mcfg.rewtype = 'ref';
mcfg.Aref = 1;
mcfg.bref = -2;
mcfg.refx0 = x0;
dummym = switchedlin_problem('model', mcfg);

cfg = struct;
cfg.problem = 'switchedlin_problem';
cfg.model_params = {mcfg};
cfg.gamma = 0.5;
cfg.maxsteps = 1600;
cfg.planalg = 'opd';
cfg.planparams.U = [1 2];
cfg.planparams.n = 100;
cfg.verb = 3;

%% run OPD allowing any initial mode
cfg.reset = x0;
cfg.run = 1;
cfg.datafile = 'swtracking_test';
genmpc(cfg);

h = genmpc(['plottrial datafile=' cfg.datafile ' plottarget=beamer savefig=' cfg.datafile]);
