%% Common config
% close all;
clear all;

Uval = 4;
mcfg = struct;
mcfg.filter = 'none';
mcfg.rewtype = 'normadams';  % normalized!
odecfg = struct;
% algo config
cfg = struct;
cfg.planparams.U = flat({[0, 0.7], [0, 0.3]});
cfg.trials = 1;
cfg.reset = 'unhealthy';
cfg.maxsteps = 800/5;
cfg.verb = 3;
cfg.datadir = pwd;
cfg.problem = 'hiv_problem';
cfg.model_params = {mcfg, odecfg}; 
cfg.gamma = 0.98;
ccfg = cfg;

%% ONLINE OSP_reuse with n
tic;
cfg = ccfg;
cfg.planalg = 'osp_reuse';            % variant: optimistic planning for deterministic systems
cfg.planparams.n = 250;         % budget of expansions at each step
cfg.planparams.S = 2;
cfg.datafile = ['iponl_osp_reuse_U' num2str(Uval) '_n=' num2str(cfg.planparams.n) '_S=' num2str(cfg.planparams.S)];
cfg.visualize = 4;
% cfg.saveplandata = 1;

% run the algorithm
cfg.run = 1;
genmpc_reuse(cfg);          

genmpc_reuse(['ploth datafile=' cfg.datafile]);

figure; hist=genmpc(['plottrial datafile=' cfg.datafile]);
fprintf('total return=%.5f\n\n',hist.R(1));
toc;

% for i=1:60, t1(i)=planinfoh(i).treesize; end;
% for i=1:60, t2(i)=planinfoh(i).treesize; end;
% plot(1:60,t`, 1:60,t2)

%% ONLINE OSP with n
tic;
cfg = ccfg;
cfg.planalg = 'osp';            % variant: optimistic planning for deterministic systems
cfg.planparams.n = 300;         % budget of expansions at each step
cfg.planparams.S = 2;
cfg.datafile = ['iponl_osp_U' num2str(Uval) '_n=' num2str(cfg.planparams.n) '_S=' num2str(cfg.planparams.S)];
cfg.visualize = 4;
% cfg.saveplandata = 1;

% run the algorithm
cfg.run = 1;
genmpc(cfg);          

genmpc(['ploth datafile=' cfg.datafile]);

figure; hist=genmpc(['plottrial datafile=' cfg.datafile]);
fprintf('total return=%.5f\n\n',hist.R(1));
toc;

% for i=1:60, t1(i)=planinfoh(i).treesize; end;
% for i=1:60, t2(i)=planinfoh(i).treesize; end;
% plot(1:60,t`, 1:60,t2)


%% ONLINE OSP with n
tic;
cfg = ccfg;
cfg.planalg = 'opd';            % variant: optimistic planning for deterministic systems
cfg.planparams.n = 200;         % budget of expansions at each step
cfg.planparams.S = 2;
cfg.datafile = ['iponl_opd_U' num2str(Uval) '_n=' num2str(cfg.planparams.n) '_S=' num2str(cfg.planparams.S)];
cfg.visualize = 4;
% cfg.saveplandata = 1;

% run the algorithm
cfg.run = 1;
genmpc(cfg);          

genmpc(['ploth datafile=' cfg.datafile]);

figure; hist=genmpc(['plottrial datafile=' cfg.datafile]);
fprintf('total return=%.5f\n\n',hist.R(1));
toc;

% for i=1:60, t1(i)=planinfoh(i).treesize; end;
% for i=1:60, t2(i)=planinfoh(i).treesize; end;
% plot(1:60,t`, 1:60,t2)


%% ONLINE OSP_OC with n
tic;
cfg = ccfg;
% cfg.maxsteps = 100/5;
cfg.planalg = 'osp_oc';            % variant: optimistic planning for deterministic systems
cfg.planparams.n = 100;         % budget of expansions at each step
cfg.planparams.S = 6;
cfg.planparams.N = 12; % this is related to ccfg.maxsteps = 60;

cfg.datafile = ['hivonl_osp_oc3_nsim=' num2str(cfg.planparams.n) '_S=' num2str(cfg.planparams.S) '_N=' num2str(cfg.planparams.N)];
cfg.visualize = 0;
% cfg.saveplandata = 1;

% run the algorithm
cfg.run = 1;
genmpc_oc(cfg);          

genmpc_oc(['ploth datafile=' cfg.datafile]);

figure; hist=genmpc(['plottrial addtocrt datafile=' cfg.datafile]);
fprintf('total return=%.5f\n\n',hist.R(1));
toc;

% for i=1:60, t1(i)=planinfoh(i).treesize; end;
% for i=1:60, t2(i)=planinfoh(i).treesize; end;
% plot(1:60,t`, 1:60,t2)


%% ONLINE OSP_OC with n
tic;
cfg = ccfg;
cfg.maxsteps = 800/5;
cfg.planalg = 'osp_oc_reuse';            % variant: optimistic planning for deterministic systems
cfg.planparams.n = 500;         % budget of expansions at each step
cfg.planparams.S = 8;
cfg.planparams.N = 12; % this is related to ccfg.maxsteps = 60;

cfg.datafile = ['hivonl_osp_oc_reuse_U' num2str(Uval) '_n=' num2str(cfg.planparams.n) '_S=' num2str(cfg.planparams.S) '_N=' num2str(cfg.planparams.N)];
cfg.visualize = 0;
% cfg.saveplandata = 1;

% run the algorithm
cfg.run = 1;
genmpc_oc(cfg);          

genmpc_oc(['ploth datafile=' cfg.datafile]);

figure; hist=genmpc(['plottrial addtocrt datafile=' cfg.datafile]);
fprintf('total return=%.5f\n\n',hist.R(1));
toc;

% for i=1:60, t1(i)=planinfoh(i).treesize; end;
% for i=1:60, t2(i)=planinfoh(i).treesize; end;
% plot(1:60,t`, 1:60,t2)