close all; clear all;

nsims = [600:900:4200 6000 7500 9000:3000:24000];
tarray=zeros(5,length(nsims));
algo_i=1;
for algo={{'opd'},{'osp'},{'usp'}};
    algon = algo{1}{1};
    if ~strcmp(algon,'opd'), 
        Svals = [2 4];
    else
        Svals=1;
    end;
    for S=Svals
        for nsim=nsims
            fname = ['iponl_U2_' algon '_nsim=' num2str(nsim)];
            if ~strcmp(algon,'opd'), fname=[fname '_S=' num2str(S) '.mat'];
            else
                fname = [fname '.mat'];
            end
            matf = load(fname, 'timestat');   
            tarray(algo_i,nsims==nsim) = matf.timestat.run;
        end
        algo_i = algo_i + 1;
    end
end

for algo_i=1:5
    plotlinestyle = {'k-o', 'k-s', 'k--*', 'k-.d', 'k:+', 'k-x', 'k--^', 'k-.o', 'k--^', 'k-^', 'k:*', 'k-.^', 'k:o'};
    plot(nsims./3,tarray(algo_i,:),plotlinestyle{algo_i});
    hold on;
end

xlabel('computational budget n');
ylabel('execution time');
legend('opd','osp S=2','osp  S=4','usp  S=2','usp  S=4');