function [xd, S, xplus] = sw_101(t, x, mode)

if isempty(mode),
    theta = x(1); phi = x(2);
%     thetadot = x(3); phidot = x(4);
    S = cos(theta)-cos(phi-theta);
    xd = [];
    xplus = [];
elseif imag(mode),  % state and/or S reset
    theta = x(1); % phi = x(2);
    thetadot = x(3); % phidot = x(4);
%     if (theta < -0.03) && (x(3) < 0) && (phi < -0.01) && real(mode) < 0,
    if real(mode) < 0,
        % swing leg impact validated
        xplus = [-theta
                -2*theta
                cos(2*theta)*thetadot
                cos(2*theta)*(1 - cos(2*theta))*thetadot];   
        S = real(mode);
        xd = [];
    else
        % ignore event, direction is incorrect or conditions on state not satisfied
        xplus = x;
        xd = [];
        S = real(mode);
    end;
else                % model is the same in-between any events
    theta = x(1); phi = x(2);
    % thetadot = x(3); phidot = x(4);
    xd = [x(3)
          x(4)
          sin(theta-0.004)
          sin(phi)*(x(3)^2-cos(theta-0.004)) + sin(theta-0.004) + 0];
    S = cos(theta)-cos(phi-theta);        
    xplus = [];
%     isterminal  = [(theta < -0.03) & (x(3) < 0) & (phi < -0.01);  1];
%     direction   = [-1; -1];
end
