%% init

ccfg = struct;
ccfg.problem = 'ipsetup_problem';
ccfg.model_params = {'nlqr', 'type=ip maxu=3 stoch_prob=[.6,.4] stoch_gain=[1,.7]', 'Ts=0.05'};
ccfg.gamma = 0.95;
ccfg.trials = 1;
ccfg.maxsteps = 40;
ccfg.reset = [-pi, 0]';
ccfg.saveplandata = 1;
ccfg.verb = 3;
ccfg.visualize = 0;
ccfg.datadir = pwd;


%% UCT
cfg = ccfg;
cfg.planalg = 'uct';
cfg.planparams.n = 10000;
cfg.planparams.U = [-3 3];
cfg.planparams.verb = 1;
% cfg.planparams.depth = 300;
cfg.planparams.Cp = 0.5;
%
cfg.datafile = 'test_genmpc_uct_stochipsetup';
cfg.run = 1;
genmpc(cfg);



%% Simple, robot cleaner test experiment
mcfg = struct; cfg = struct;

N = 10; mcfg.X = {[0:N-1]}; mcfg.x_energy = 0; mcfg.x_can = N-1;  % larger world
mcfg.rew_energy = 0.2;  mcfg.rew_can = 1;   % must be in [0, 1]
mcfg.prob_char = [0.2 0];   % stochastic, 20% chance of standing still

cfg.problem = 'cleanrob_problem';
cfg.model_params = {mcfg}; 
cfg.gamma = 0.7;
cfg.planalg = 'uct';
cfg.planparams.n = 30;
cfg.planparams.U = [-1 1];
cfg.planparams.verb = 0;
cfg.planparams.Cp = 0.5;
cfg.trials = 1;
cfg.maxsteps = 30;
cfg.reset = [4];
%
% cfg.saveplandata = 1;
cfg.visualize = 2;
cfg.datadir = pwd;
cfg.datafile = 'test_genmpc_clopfinite_detcleanrob_contrib';

cfg.run = 1;
genmpc(cfg);

