%% SOOP/LP on invpend
global T_BVAL T_DIMSEL T_DIMSEL2
T_BVAL = [0 0]; T_DIMSEL = [0 0]; T_DIMSEL2 = [0 0];

cfg = struct;

cfg.problem = 'ipsetup_problem';
% cfg.model_params = {'nlqr', 'type=ip maxu=3', 'Ts=0.05'};
% algo should work on this model:
cfg.model_params = {'rewtype=nlqr Qrew=[1,0;0,0] Rrew=0.3', 'type=ip maxu=3', 'Ts=0.05'};
cfg.gamma = 0.95;
% cfg.planalg = 'soop_onlydimdiscountsplitting'; cfg.planparams.dimselect = 'discount'; cfg.planparams.alpha = 0.8;
% cfg.planparams.dimselect = 'all';
cfg.planparams.method = 'lp'; cfg.planparams.dimselect = 'lp'; cfg.planparams.lipschitz = 0.9;
cfg.planalg = 'sooplp';
cfg.planparams.n = 2500;
cfg.planparams.verb = 1;
cfg.online = 1;
cfg.reset = [-pi; 0];
cfg.maxsteps = 40;
%
cfg.saveplandata = 1;
cfg.verb = 3;
cfg.visualize = 0;
cfg.datadir = pwd;
cfg.datafile = 'test_lp_ipsetup_n2500.mat';
cfg.run = 1;
genmpc(cfg);

genmpc('plottrial datafile=test_genmpc_opd_variants_ndepth-n_online');

%% SOOP/LP on dc motor -- for cpu time tests
global T_BVAL T_DIMSEL T_DIMSEL2
T_BVAL = [0 0]; T_DIMSEL = [0 0]; T_DIMSEL2 = [0 0];

cfg = struct;

cfg.problem = 'dc_problem';
cfg.model_params = {'rewtype=nlqr Q=[1,0;0,.001] R=.05', 'type=lin maxx=[pi;15*pi] maxu=10 Ts=0.01'};
cfg.gamma = 0.95;
cfg.planparams.method = 'lp'; cfg.planparams.dimselect = 'lp'; cfg.planparams.lipschitz = 0.1;
cfg.planalg = 'sooplp';
cfg.planparams.n = 1000;
cfg.planparams.verb = 1;
cfg.online = 1;
cfg.reset = [-pi; 0];
cfg.maxsteps = 25;
%
cfg.saveplandata = 1;
cfg.verb = 3;
cfg.visualize = 0;
cfg.datadir = pwd;
cfg.datafile = 'test_lp_dc_cputime';
cfg.run = 1;
genmpc(cfg);

T_BVAL, avgb = T_BVAL(2) / T_BVAL(1)
T_DIMSEL, avg1 = T_DIMSEL(2) / T_DIMSEL(1)
T_DIMSEL2, avg2 = T_DIMSEL2(2) / T_DIMSEL2(1)

%% HOLOP
cfg = struct;

cfg.problem = 'ipsetup_problem';
cfg.model_params = {'rewtype=nlqr Qrew=[1,0;0,0] Rrew=0.3', 'type=ip maxu=3', 'Ts=0.05'};
cfg.gamma = 0.95;
cfg.planalg = 'holop';
cfg.planparams.n = 5000;
cfg.planparams.K = 15;
cfg.planparams.detact = 1; 
cfg.planparams.verb = 1;
cfg.online = 1;
cfg.reset = [-pi; 0];
cfg.maxsteps = 40;
%
cfg.saveplandata = 0;
cfg.verb = 3;
cfg.visualize = 0;
cfg.datadir = pwd;
cfg.datafile = 'test_holop_ipsetup_n5000_K15_detact';
cfg.run = 1;
genmpc(cfg);

genmpc('plottrial datafile=test_genmpc_opd_variants_ndepth-n_online');

%% SOOP on bike
cfg = struct;

cfg.problem = 'bike2012_problem';
% sine
% cfg.model_params = {struct('reftraj', sin(2*pi/10*(0:.05:20)))};
% constant
% cfg.model_params = {struct('Qrew', diag([1 0 0 0 0]), 'reftraj', zeros(1, ceil(20/.05)))};
cfg.model_params = {struct('rewtype', 'nlqr', 'Qrew', diag([1 0 0 0 0]))};
cfg.gamma = 0.95;
cfg.planalg = 'sooplp';
cfg.planparams.method = 'soop';
cfg.planparams.dimselect = 'disc';
cfg.planparams.alpha= 0.9;
cfg.planparams.n = 3000;
cfg.planparams.verb = 1;
cfg.online = 1;
cfg.reset = [5*pi/180 0 0 0 0];
cfg.maxsteps = ceil(10/.05);    % 10 seconds
%
cfg.saveplandata = 0;
cfg.verb = 3;
cfg.visualize = 0;
cfg.datadir = pwd;
cfg.datafile = 'test_soop_biketracking';
cfg.run = 1;
genmpc(cfg);

%% for baseline: OPD on bike (based on earlier results should be able to easily deal with balancing)
cfg = struct;

cfg.problem = 'bike2012_problem';
cfg.model_params = {struct('inputs', 'both', 'rewtype', 'nlqr', 'Qrew', diag([1 0 0 0 0]), 'Rrew', diag([0, 0]))};
cfg.gamma = 0.95;
cfg.planalg = 'opd';
cfg.planparams.U = flat({[-.02 0 .02], [-2 0 2]});
% cfg.planparams.U = [-.02 0 .02];
% cfg.planparams.U = [-2 0 2];
cfg.planparams.n = 5000;
cfg.planparams.verb = 1;
cfg.online = 1;
cfg.reset = [5*pi/180 0 0 0 0];
cfg.maxsteps = ceil(5/.03);    
%
cfg.saveplandata = 0;
cfg.verb = 3;
cfg.visualize = 0;
cfg.datadir = pwd;
cfg.datafile = 'test_opd_bikebalancing';
cfg.run = 1;
genmpc(cfg);


