
%% Main config 1: model: use the params in Robert's acrobot example (NO Sutton & Barto Section 11.3)
mcfg = struct;
mcfg.type = 'acrobot';
mcfg.len = [.15 .25];
mcfg.m = [1 1];
mcfg.c = mcfg.len;  % center of mass coords
mcfg.I = [0 0];
mcfg.b = [0 0];
mcfg.Q = diag([1 0 1 0]);
mcfg.maxtau = [NaN; 2];
mcfg.R = 0;
mcfg.orientation = 'horiz';
mcfg.rewtype = 'nlqr';
model = rarm_problem('model', mcfg);

%% Main config 2: rotpend
mcfg = struct;
mcfg.type = 'rotpend';
mcfg.len = [.15 .25];
mcfg.m = [1 1];
mcfg.c = mcfg.len;  % center of mass coords
mcfg.I = [0 0];
mcfg.b = [0 0];
mcfg.Q = diag([1 0 1 0]);
mcfg.maxtau = [2; NaN];
mcfg.R = 0;
mcfg.orientation = 'horiz';
mcfg.rewtype = 'nlqr';
model = rarm_problem('model', mcfg);


%% Fuzzy QI solution

cfg = struct;
cfg.problem = 'rarm_problem';
cfg.model_params = {mcfg};
cfg.xgrids = symloggrid([13 7 13 7], model.maxx);
cfg.ugrids = {symloggrid(7, model.maxu)};   % fuzzyqi expects cell array so wrap as one
cfg.gamma = 0.98;
cfg.eps = 1e-5;
cfg.maxiter = 1000;
cfg.datadir = pwd;
cfg.datafile = 'test_soop_rarmrotpend_fzqisol';
cfg.run = 1;
cfg.verb = 10;
cfg.initstepdisp = 0.1;
cfg.itersave = 100;
fuzzyqi(cfg);

%% 
cfg = struct;
cfg.problem = 'rarm_problem';
cfg.model_params = {mcfg}; 
cfg.gamma = 0.98;
cfg.planalg = 'sooplp';
cfg.planparams.method = 'soop';
cfg.planparams.n = 5000;
cfg.planparams.dimselect = 'disc';
cfg.planparams.alpha = 0.7;
cfg.planparams.verb = 1;
cfg.trials = 1;
cfg.maxsteps = 100;
cfg.reset = [-pi, 0, -pi, 0]';
%
cfg.saveplandata = 0;
cfg.verb = 3;
cfg.visualize = 0;
cfg.datadir = pwd;
cfg.datafile = 'test_soop_rarmrotpend_soop';
cfg.run = 1;
genmpc(cfg);



