%% Run OPD on doubleint for debug purposes
% model and representative initial states
mcfg = struct;
mcfg.type = 'doubleint'; mcfg.nagents = 6; mcfg.dim = 1; mcfg.Ts = 1;
mcfg.range = 5; mcfg.flock_dist = 5; mcfg.flock_maxdvel = 5;


% magenmpc_malin_1dbudget_n15_nU7_predlenInf -- recovers after long period disconnected
% magenmpc_malin_1dbudget_n100_nU7_predlenInf -- two one-step disconnects
m = malinear_problem('model', mcfg);
p0 = 0:0.4*mcfg.range:0.4*mcfg.range*(mcfg.nagents-1);
[Grob, rhorob, lambda2rob] = malinear_problem('minrobgraph', m, [p0; zeros(1, mcfg.nagents)]);

vrob = lambda2rob * rhorob / sqrt(2) / sqrt(m.nagents);
% % case 1): condition satisfied
% x0{1} = [p0; vrob * [-ones(1, m.nagents/2) ones(1, m.nagents/2)]];
% % case 2): condition violated but with intermediate value
% x0{2} = [p0; 1.5 * vrob * [-ones(1, m.nagents/2) ones(1, m.nagents/2)]];
% % case 3): condition violated with large value
x0 = [p0; 2.5 * vrob * [-ones(1, m.nagents/2) ones(1, m.nagents/2)]];

% algorithms
cfg = struct;
cfg.problem = 'malinear_problem';
cfg.model_params = {mcfg};
cfg.comm = 'seq';
cfg.online = 1;
cfg.gamma = 0.98;
cfg.planalg = 'maopd_predictneighbors';
% uniform tree of depth H for n=5: H=3 n=156, H=4 n=781
% uniform tree of depth H for n=5: H=2 n=57, H=3 n=400
cfg.planparams.U = repmat({symloggrid(5, .3)}, 1, mcfg.nagents);
cfg.planparams.criterion = 'optim';
cfg.planparams.n = 50;
cfg.planparams.rob = 0;
cfg.planparams.maxpredlength = Inf;
cfg.planparams.verb = 2;
% in case we use online
cfg.trials = 1;
cfg.saveplandata = 1;
cfg.maxsteps = 40;
cfg.visualize = 3;

% visualization
cfg.verb = 3;
cfg.datadir = pwd;
cfg.steps = [];
cfg.reset = x0(:);
cfg.run = 1;

%% Always simulate
cfg.planparams.xpredtype = 'sim';
cfg.datafile = 'opdpredneighb_xpredsim_revised';
magenmpc(cfg);

%% Use state predictions
cfg.planparams.xpredtype = 'comm';
cfg.datafile = 'opdpredneighb_xpredcomm_revised';
magenmpc(cfg);


