% Test variant of OPSS that uses handle objects for the tree nodes 

%% Test memory in stoch invpend
cfg = struct;
 
cfg.problem = 'ipsetup_problem';
cfg.model_params = {'nlqr', 'type=ip maxu=3 stoch_prob=[.7,.3] stoch_gain=[1,.7]', 'Ts=0.05'};
cfg.gamma = 0.95;
cfg.planalg = 'opss';
cfg.planparams.n = 1000;
cfg.planparams.L = 2;
cfg.planparams.U = [-3 0 3];
cfg.planparams.usemem = 1; 
cfg.planparams.mem_maxsize = 0;
cfg.planparams.lipschitz = 0.25; 
cfg.planparams.verb = 2;

% 
cfg.online = 1;
cfg.x0 = [-pi; 0];
cfg.trials = 1;
cfg.maxsteps = 50;
% 
cfg.saveplandata = 0;
cfg.verb = 3; 
cfg.visualize = 0;
cfg.datadir = pwd;
cfg.datafile = 'test_ip_stoch_opss_usemem';
cfg.run = 1;
genmpc(cfg);

genmpc('plottrial datafile=test_ip_stoch_opss_usemem');

%% Test memory in determ invpend
cfg = struct;
 
cfg.problem = 'ipsetup_problem';
cfg.model_params = {'nlqr', 'type=ip maxu=3', 'Ts=0.05'};
cfg.gamma = 0.95;
cfg.planalg = 'opss';
cfg.planparams.n = 75;
cfg.planparams.L = 1;
cfg.planparams.U = [-3 0 3];
cfg.planparams.usemem = 1; 
cfg.planparams.mem_maxsize = 200;
cfg.planparams.lipschitz = 0.25;  
cfg.planparams.verb = 3;

% 
cfg.online = 1;
cfg.x0 = [-pi; 0];
cfg.trials = 1;
cfg.maxsteps = 50;
% 
cfg.saveplandata = 0;
cfg.verb = 3; 
cfg.visualize = 0;
cfg.datadir = pwd;
cfg.datafile = 'test_ip_det_opss_usemem';
cfg.run = 1;
genmpc(cfg);

genmpc('plottrial datafile=test_ip_det_opss_usemem');

%% Test memory in simple integrator with visualization
cfg = struct;

cfg.problem = 'int_problem';
cfg.model_params = {'nlqr'};
cfg.gamma = 0.9;
cfg.planalg = 'opss';
cfg.planparams.n = 100;
cfg.planparams.L = 1;
cfg.planparams.U = [-2 2];
cfg.planparams.usemem = 1;
cfg.planparams.lipschitz = 1;  
cfg.planparams.verb = 3;        % 3 = visualize memory
%
cfg.online = 1;
cfg.x0 = [-5; 0];
cfg.trials = 1;
cfg.maxsteps = 50;
%
cfg.saveplandata = 0;
cfg.verb = 3;
cfg.visualize = 0;
cfg.datadir = pwd;
cfg.datafile = 'test_int_det_opss_usemem';
cfg.run = 1;
genmpc(cfg);

genmpc('plottrial datafile=test_int_det_opss_usemem');


%% Baseline stoch IP
% rand('twister', 10);
cfg = struct;

cfg.problem = 'ipsetup_problem';
cfg.model_params = {'nlqr', 'type=ip maxu=3 stoch_prob=[.7,.3] stoch_gain=[1,.7]', 'Ts=0.05'};
cfg.gamma = 0.95;
cfg.planalg = 'opss';
cfg.planparams.n = 200;
cfg.planparams.L = 2;
cfg.planparams.U = [-3 0 3];
cfg.planparams.verb = 1;
%
cfg.online = 1;
cfg.x0 = [-pi; 0];
cfg.trials = 1;
cfg.maxsteps = 50;
%
cfg.saveplandata = 0;
cfg.verb = 3;
cfg.visualize = 0;
cfg.datadir = pwd;
cfg.datafile = 'test_ip_stoch_opss_noreuse';
cfg.run = 1;
genmpc(cfg);

genmpc('plottrial datafile=test_ip_stoch_opss_noreuse'); 


%% Test tree reuse in stoch IP
cfg = struct;

cfg.problem = 'ipsetup_problem';
cfg.model_params = {'nlqr', 'type=ip maxu=3 stoch_prob=[.7,.3] stoch_gain=[1,.7]', 'Ts=0.05'};
cfg.gamma = 0.95;
cfg.planalg = 'opss';
cfg.planparams.n = 200;
cfg.planparams.L = 2;
cfg.planparams.U = [-3 0 3];
cfg.planparams.reusetree = 1;
cfg.planparams.reusetree_maxsize = 10000;
%
cfg.online = 1;
cfg.x0 = [-pi; 0];
cfg.trials = 1;
cfg.maxsteps = 50;
%
cfg.saveplandata = 1;
cfg.verb = 3;
cfg.visualize = 0;
cfg.datadir = pwd;
cfg.datafile = 'test_ip_stoch_opss_treereuse';
cfg.run = 1;
genmpc(cfg);

genmpc('plottrial datafile=test_ip_stoch_opss_treereuse');


%% Test tree reuse in determ  IP == difference should be clearer
cfg = struct;

cfg.problem = 'ipsetup_problem';
cfg.model_params = {'nlqr', 'type=ip maxu=3', 'Ts=0.05'};
cfg.gamma = 0.95;
cfg.planalg = 'opss';
cfg.planparams.n = 75;
cfg.planparams.L = 1;
cfg.planparams.U = [-3 0 3];
cfg.planparams.verb = 1;
%
cfg.online = 1;
cfg.x0 = [-pi; 0];
cfg.trials = 1;
cfg.maxsteps = 50;
%
cfg.saveplandata = 0;
cfg.verb = 3;
cfg.visualize = 0;
cfg.datadir = pwd;
cfg.datafile = 'test_ip_det_opss_noreuse';
cfg.run = 1;
genmpc(cfg);

genmpc('plottrial datafile=test_ip_det_opss_noreuse');


%% 
cfg = struct;

cfg.problem = 'ipsetup_problem';
cfg.model_params = {'nlqr', 'type=ip maxu=3', 'Ts=0.05'};
cfg.gamma = 0.95;
cfg.planalg = 'opss';
cfg.planparams.n = 75;
cfg.planparams.L = 2;
cfg.planparams.U = [-3 0 3];
cfg.planparams.verb = 0;
cfg.planparams.reusetree = 1;
%
cfg.online = 1;
cfg.x0 = [-pi; 0];
cfg.trials = 1;
cfg.maxsteps = 50;
%
cfg.saveplandata = 0;
cfg.verb = 3;
cfg.visualize = 0;
cfg.datadir = pwd;
cfg.datafile = 'test_ip_det_opss_treereuse';
cfg.run = 1;
genmpc(cfg);

genmpc('plottrial datafile=test_ip_det_opss_treereuse');


%% Simple, robot cleaner test experiment
mcfg = struct; cfg = struct;

mcfg.X = {[0:7]}; mcfg.x_energy = 0; mcfg.x_can = 7;  % larger world
mcfg.rew_energy = 0.2;  mcfg.rew_can = 1;   % must be in [0, 1]
mcfg.prob_char = [0.2 0];   % stochastic, 20% chance of standing still

cfg.problem = 'cleanrob_problem';
cfg.model_params = {mcfg}; 
cfg.gamma = 0.5;
cfg.planalg = 'opss';
cfg.planparams.n = 5;
cfg.planparams.L = 2;
cfg.planparams.criterion = 'contrib';
cfg.planparams.U = [-1 1];
cfg.planparams.verb = 2;
cfg.planparams.reusetree = 1;
cfg.trials = 1;
cfg.maxsteps = 30;
cfg.reset = 4;
%
cfg.saveplandata = 1;
cfg.visualize = 2;
cfg.datadir = pwd;
cfg.datafile = 'test_opss_treereuse_cleanrob';

cfg.run = 1;
genmpc(cfg);
