%% Test policy tree (variant that supports subtrees, 11 june 2013)
cfg = struct;

rand('twister', 100);

cfg.problem = 'ipsetup_problem';
cfg.model_params = {'nlqr', 'type=ip maxu=3 stoch_prob=[.6,.3,.1] stoch_gain=[1,.7,.3]', 'Ts=0.05'};
cfg.gamma = 0.95;
cfg.actiontype = 'seq';
cfg.planalg = 'opss';
cfg.planparams.n = 1500;
cfg.planparams.L = 3;
cfg.planparams.U = [-3 0 3];
cfg.planparams.verb = 2;
% cfg.planparams.depth = 7;
% cfg.planparams.depthprime = 4;
cfg.planparams.depthprime = .5;

% 
cfg.online = 1;
cfg.reset = [-pi; 0];
cfg.trials = 1;
cfg.maxsteps = 50;
% 
cfg.saveplandata = 1;
cfg.verb = 3; 
cfg.visualize = 0;
cfg.datadir = pwd;
cfg.datafile = 'test_ip_opss_policytree';
cfg.run = 1;
genmpc(cfg);

genmpc('plottrial datafile=test_ip_opss_policytree');



%% Test policy tree with target effective depth
cfg = struct;

rand('twister', 100);

cfg.problem = 'ipsetup_problem';
cfg.model_params = {'nlqr', 'type=ip maxu=3 stoch_prob=[.7,.3] stoch_gain=[1,.6]', 'Ts=0.05'};
cfg.gamma = 0.95;
cfg.actiontype = 'seq';
cfg.planalg = 'opss';
% cfg.planparams.n = 1500;
cfg.planparams.L = 2;
cfg.planparams.U = [-3 0 3];
cfg.planparams.verb = 2;
cfg.planparams.depth = 6;
cfg.planparams.depthprime = 2;
% cfg.planparams.depthprime = .5;

% 
cfg.online = 1;
cfg.reset = [-pi; 0];
cfg.trials = 1;
cfg.maxsteps = 50;
% 
cfg.saveplandata = 1;
cfg.verb = 3; 
cfg.visualize = 0;
cfg.datadir = pwd;
cfg.datafile = 'test_ip_opss_policytree';
cfg.run = 1;
genmpc(cfg);

genmpc('plottrial datafile=test_ip_opss_policytree');






%% Test policy tree against baseline (variant that supports subtrees, 11 june 2013)
cfg = struct;

rand('twister', 100);

cfg.problem = 'ipsetup_problem';
cfg.model_params = {'nlqr', 'type=ip maxu=3 stoch_prob=[.7,.2,.1] stoch_gain=[1,.8,.6]', 'Ts=0.05'};
cfg.gamma = 0.95;
cfg.actiontype = 'seq';
cfg.planalg = 'opss';
cfg.planparams.n = 1000;
cfg.planparams.L = 3;
cfg.planparams.U = [-3 0 3];
cfg.planparams.verb = 2;

% 
cfg.online = 1;
cfg.x0 = [-pi; 0];
cfg.trials = 1;
cfg.maxsteps = 50;
% 
cfg.saveplandata = 1;
cfg.verb = 3; 
cfg.visualize = 0;
cfg.datadir = pwd;
cfg.datafile = 'test_ip_opss_policytree';
cfg.run = 1;
genmpc(cfg);

genmpc('plottrial datafile=test_ip_opss_policytree');



%% baseline with previous implementation
% note the genmpc_old assumes that if ANY children of current nodes are leaves, then all are -- so
% it stops with the policy. this is an incorrect assumption

% nevertheless the new implementation (when using this wrong test) fully replicates the results of
% the old one
cfg = struct;
 
rand('twister', 100);

cfg.problem = 'ipsetup_problem';
cfg.model_params = {'nlqr', 'type=ip maxu=3 stoch_prob=[.7,.2,.1] stoch_gain=[1,.8,.6]', 'Ts=0.05'};
cfg.gamma = 0.95;
cfg.actiontype = 'seq';
cfg.planalg = 'opss_old';
cfg.planparams.n = 1000;
cfg.planparams.L = 3;
cfg.planparams.U = [-3 0 3];
cfg.planparams.verb = 2;

% 
cfg.online = 1;
cfg.x0 = [-pi; 0];
cfg.trials = 1;
cfg.maxsteps = 50;
% 
cfg.saveplandata = 1;
cfg.verb = 3; 
cfg.visualize = 0;
cfg.datadir = pwd;
cfg.datafile = 'test_ip_opss_policytree_oldbaseline';
cfg.run = 1;
genmpc_old(cfg);

genmpc_old('plottrial datafile=test_ip_opss_policytree_oldbaseline');
