%% main config
ccfg = struct;
ccfg.gamma = .98;
ccfg.datadir = pwd;
% the "standard" ipsetup approximator
ccfg.approx = 'enhanced type=rbfdisc N=11 M=3';
% and learning settings
ccfg.trialtime = 2;
ccfg.maxtime  = 1000;
ccfg.alpha = .5;
ccfg.lambda = .5;
ccfg.explor = 1;
ccfg.explordecay = .98;
ccfg.randseed = 1000;
% reset 
ccfg.reset = 'rand';
% stats settings
ccfg.verb = 5;
ccfg.eps = 0;


%% run real-time algorithm, with dummy problem
cfg = ccfg;
cfg.problem = 'ipsetup_dummy_rtproblem';
cfg.run = 1;
cfg.datafile = 'test_rtapproxqlearn_ip';
rtapproxqlearn(cfg);


%% run simulation algorithm, as a baseline
cfg = ccfg;
cfg.problem = 'ipsetup_problem';
cfg.run = 1;
cfg.datafile = 'test_rtapproxqlearn_ip_approxqlearnbaseline';
approxqlearn(cfg);

% Note the solutions should be SIMILAR, but not the same! since the simulation algorithm does:
% - apply u
% - immediately get x'
% - update Q with transition to x'
% - apply next u
%
% Whereas the real-time algorithm does:
% - apply u
% - do some work
% - read x'
% - apply next u
% - ONLY NOW update Q with transition to x'

% (This seems to make quite a difference in the policy)



%% run real-time algorithm, with short times and debugging settings
cfg = ccfg;
cfg.problem = 'ipsetup_dummy_rtproblem';
cfg.run = 1;
cfg.trialtime = .1;
cfg.maxtime  = 1;
cfg.datafile = 'test_rtapproxqlearn_ip_debug';
cfg.verb = 5;
rtapproxqlearn(cfg);

