mode = 'run';

% main cfg
ccfg = struct;
ccfg.(mode) = 1;
ccfg.problem = 'ipsetup_problem';
ccfg.model_params = {[], 'type=ip maxu=3', 'Ts=0.005'};
ccfg.gamma = .98;
ccfg.datadir = pwd;
% the "standard" ipsetup approximator
ccfg.approx = 'enhanced type=rbfdisc N=11 M=3';
% and learning settings
ccfg.dupd = .05;
ccfg.trialtime = 1.5;  
ccfg.maxtime  = 600*1;           % 10 mins
ccfg.explor = 1;
ccfg.explordecay = 0.1^(1/ccfg.maxtime);  
% reset 
ccfg.x0 = [-pi; 0];             % to this initial state
ccfg.resetper = 10;             % (for mixed schedules), use secondary reset once this # of trials
% stats settings
ccfg.dstoretheta = 1.5;         % store theta once every trial
ccfg.verb = 5;
ccfg.ddisp = 3;
ccfg.dsave = 30;                % save once every halfminute
ccfg.verb = 5;
ccfg.eps = 0;

% % Reset to fixed initial state
% cfg = ccfg;
% cfg.reset = 'fixed';
% cfg.datafile = 'resettest_fixed_lspionline';
% lspionline(cfg);

% % Reset to rand initial state
% cfg = ccfg;
% cfg.reset = 'rand';
% cfg.datafile = 'resettest_rand_lspionline';
% lspionline(cfg);

% Reset to fixed + rand initial state
cfg = ccfg;
cfg.reset = 'randfixed';
cfg.datafile = 'resettest_randfixed_lspionline';
lspionline(cfg);